/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2023/04/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 *GPIO routine:
 *PA0 push-pull output.
 *
 ***Only PA0--PA15 and PC16--PC17 support input pull-down.
 */

#include "debug.h"

/* Global define */

/* Global Variable */

/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0
 *
 * @return  none
 */
void GPIO_Toggle_INIT(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void TIM1_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);

    TIM_TimeBaseStructure.TIM_Period = arr;                    //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler =psc;                  //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;    //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;//TIMģʽϼģʽ
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);            //ָĲʼTIMxʱλ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;         //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure);                            //ʼNVIC

    TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE ); //ʹTIM1жϣж

    TIM_Cmd(TIM3, ENABLE); //TIM1ʹ
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    SystemCoreClockUpdate();
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
    printf("GPIO Toggle TEST\r\n");

    GPIO_Toggle_INIT();
    TIM1_Int_Init(100-1,SystemCoreClock/1000000-1);

    while(1)
    {
        ;
    }
}

void TIM3_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM3_IRQHandler(void)
{
    static u8 i=0;

    if(TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET) //TIM1жǷ
    {
        TIM_ClearITPendingBit(TIM3,TIM_IT_Update);      //TIM1жϹλ
        GPIO_WriteBit(GPIOA, GPIO_Pin_6, (i==0) ? (i=Bit_SET):(i=Bit_RESET));
    }
}
